require "zeitwerk"

module Lono
  module Pro
    class Autoloader
      class Inflector < Zeitwerk::Inflector
        def camelize(basename, _abspath)
          map = { cli: "CLI", version: "VERSION" }
          map[basename.to_sym] || super
        end
      end

      class << self
        def setup
          loader = Zeitwerk::Loader.new
          loader.log! if ENV["LONO_PRO_ZEITWERK_LOG"]
          loader.inflector = Inflector.new
          lib = File.expand_path("../..", __dir__) # lono-pro/lib
          loader.push_dir(lib)
          loader.ignore("#{lib}/lono-pro.rb")
          loader.setup
          loader
        end

        def require!
          setup.eager_load
        end
      end
    end
  end
end